#include <3067F.H>
#include "w6v5b.h"

/*rpT[{M*/
void generate_signal1(struct SIO *sio, struct SERVO_DATA *servo_data)
{
unsigned char	i, bitptn;

	bitptn = 1;
	for(i = 0; i < 4; i++)
	{
		ITU1.TCNT = 0;

		/**/
		PADR.BYTE = bitptn;
		PBDR.BYTE = bitptn;

		/*  0.6 msec  O*/
		while(ITU1.TCNT < 1500);

		wait_val(servo_data->data0[i]);

		PADR.BYTE = 0;
		PBDR.BYTE = 0;

		bitptn = bitptn * 2;
	}
	return;
}

/*ApT[{M*/
void generate_signal2(struct SIO *sio, struct SERVO_DATA *servo_data)
{
unsigned char	i, bitptn;

	bitptn = 16;
	for(i = 0; i < 2; i++)
	{
		ITU1.TCNT = 0;

		/**/
		PADR.BYTE = bitptn;
		PBDR.BYTE = bitptn;

		/*  0.6 msec  O*/
		while(ITU1.TCNT < 1500);

		wait_val(servo_data->data0[i]);

		PADR.BYTE = 0;
		PBDR.BYTE = 0;

		bitptn = bitptn * 2;
	}
	return;
}

/*******************************************/
/*  p^[LłqbT[{𓮂 */
/*  ݏo͒̃f[^X^[gʒuƂ */
/*******************************************/
void move_servo(struct SERVO_DATA *servo_data)
{
unsigned char	i, j;


	servo_data->brake_point = servo_data->data_num / 2;

	for(j = 0; j < 2; j++)
	{
		for(i = 0; i < 4; i++)
		{
			/**/
			if(servo_data->data0[i][j] < servo_data->data1[i][j])
			{
				servo_data->direction[i][j] =  1.0;
			}
			else
			{
				servo_data->direction[i][j] = -1.0;
			}

			if(servo_data->mode == 0)
			{
				/*xf[^*/
				servo_data->v_max[i][j] = ((float)servo_data->data1[i][j]
													- (float)servo_data->data0[i][j]) * servo_data->direction[i][j];
				servo_data->v_max[i][j] = (servo_data->v_max[i][j] / (float)servo_data->data_num) * (float)2.0;


				servo_data->a0[i][j] = servo_data->v_max[i][j] / ((float)servo_data->data_num / (float)2.0);

				/*x̏*/
				servo_data->v0[i][j] = 0.0;

				/*u[LtȌ*/
				servo_data->brake_flg[i][j] = (float)1.0;

				/*[Nϐ*/
				servo_data->data0_f[i][j] = (float)servo_data->data0[i][j];
			}
			else
			{
				servo_data->v_max[i][j] = ((float)servo_data->data1[i][j]
													- (float)servo_data->data0[i][j]) * servo_data->direction[i][j];
				servo_data->v_max[i][j] = (servo_data->v_max[i][j] / (float)servo_data->data_num);

				servo_data->a0[i][j] = 0.0;

				/*x̏*/
				servo_data->v0[i][j] = servo_data->v_max[i][j];

				/*u[LtȌ*/
				servo_data->brake_flg[i][j] = 1.0;

				/*[Nϐ*/
				servo_data->data0_f[i][j] = (float)servo_data->data0[i][j];
			}
		}
	}

	return;
}

/*********************************/
/*p^[Lœ𓮂*/
/*********************************/
void move_head(unsigned char action_com[3], struct SIO *sio, struct SERVO_DATA *servo_data)
{
unsigned char	dir_h, dir_v, dir_body;
float			q1[3];

	dir_h		= action_com[0];
	dir_v		= action_com[1];
	dir_body	= action_com[2];

	q1[0] =   (float)dir_body	- (float)90.0;
	q1[1] =   (float)dir_h		- (float)90.0;
	q1[2] = - (float)dir_v		+ (float)90.0;

	/*f[^쐬*/
	/*I_T[{f[^vZ*/
	servo_data->data1[0][0] = (unsigned int)(sio->body_newtral[0] + sio->body_propo_val[0] * q1[0]);
	servo_data->data1[0][1] = (unsigned int)(sio->body_newtral[1] + sio->body_propo_val[1] * q1[1]);
	servo_data->data1[1][1] = (unsigned int)(sio->body_newtral[2] + sio->body_propo_val[2] * q1[2]);

	move_servo(servo_data);
}

