#include <3067F.H>
#include "w6v5b.h"

/*nCp[^[~í@g 200000ŃvOX^[g(RAM)*/
void servo_update(struct SERVO_DATA *servo_data);

void main(void)
{
unsigned char	i, j;
unsigned int	ii, jj;

unsigned int	init_arm[]={3300, 300, 250, 550, 1000, 4100, 4100, 3400};

struct SIO		sio;
struct SWITCHES switches;
struct SERVO_DATA	servo_data_arm;
struct SERVO_DATA	servo_data_body;

	/*************************************************************/
	/*@g`LGA擪AhX@*/
	sio.ram0_arm = (unsigned int *)0x206000;
	sio.ram2_arm = (unsigned int *)0x205000;
	sio.ram_arm_live0 = (unsigned int *)0x2074f0;

	sio.ram0_body = (unsigned int *)0x207500;
	sio.ram2_body = (unsigned int *)0x207500;
	sio.ram_body_live0 = (unsigned int *)0x207ff8;

	switches.wave_datsum = 30;

	/*************************************************************/
	init_main();
	init_switches(&sio, &switches);

	/*************************************************************/
	/*o̓f[^*/
	for(i = 0; i < 4; i++)
	{
		servo_data_arm.data0[i][0] = init_arm[i];
		servo_data_arm.data0[i][1] = init_arm[i + 4];

		servo_data_body.data0[i][0] = 2150;
		servo_data_body.data0[i][1] = 2150;
	}

	servo_data_arm.data_num = 0;
	servo_data_body.data_num = 0;

	for(j = 0; j < 2; j++)
	{
		for(i = 0; i < 4; i++)
		{
			servo_data_arm.data1[i][j] = servo_data_arm.data0[i][j];
			servo_data_arm.a0[i][j] = 0.0;
			servo_data_arm.brake_flg[i][j] = 0.0;
			servo_data_arm.direction[i][j] = 0.0;
			servo_data_arm.v0[i][j] = 0.0;
			servo_data_arm.v_max[i][j] = 0.0;
		}
	}
	for(j = 0; j < 2; j++)
	{
		for(i = 0; i < 4; i++)
		{
			servo_data_body.data1[i][j] = servo_data_arm.data0[i][j];
			servo_data_body.a0[i][j] = 0.0;
			servo_data_body.brake_flg[i][j] = 0.0;
			servo_data_body.direction[i][j] = 0.0;
			servo_data_body.v0[i][j] = 0.0;
			servo_data_body.v_max[i][j] = 0.0;
		}
	}
	/*********************************************************************/
	/*`cwkQOQ̃j[g*/
	if(switches.adxl_on == 1)
	{
		print_s_sci1("");
		print_s_sci1("Wait 2 sec for Acc sensor stabilized.");
		wait(2000);

		ii = 0;
		jj = 0;
		for(i = 0; i < 10; i++)
		{
			read_adxl(&sio);
			ii = ii + sio.adxl_data[0];
			jj = jj + sio.adxl_data[1];
		}
		sio.adxl_newtral[0] = ii / 10;
		sio.adxl_newtral[1] = jj / 10;
	}

	print_s_sci1("Control Program for w6v5 2008/05/11");
	/*********************************************************************/
	while(1)
	{
		/*************************************************************************************/
		/***  obƂ̒ʐM                                                ****/
		/*************************************************************************************/
		if(switches.debug == 1)	sio.command = read_c_sci1b();
		else					sio.command = read_c_sci2b();
		
		if(sio.command != 0)
		{
			/*No.2 Sub CPUg̒ʐM*/
			i = sio_comm1(&sio, &switches, &servo_data_arm, &servo_data_body);
			/*No.1 Sub CPU֒p*/
			i = sio_comm2(&sio, &switches);
		}
		/*************************************************************************************/
		/***   łqb̓fR[h[`I                                        ***/
		/*************************************************************************************/
		/*T[{֏o͂M*/
		ITU0.TCNT = 0;/*20m secJEgJn*/
		if(switches.servo_on == 1)
		{
			/*r̐M*/
			generate_signal1(&sio, &servo_data_arm);

			/*̂̐M*/
			generate_signal2(&sio, &servo_data_body);
		}
		/*********************************************************************/
		/*qbT[{o̓f[^XV*/
		if(servo_data_arm.data_num > 0) servo_update(&servo_data_arm);
		if(servo_data_body.data_num > 0) servo_update(&servo_data_body);
		/*********************************************************************/
		/*Obv̎グ*/
		if(switches.live_play_arm_v > 1)
		{
			if(switches.live_dir_arm > 0)
			{
				servo_data_arm.data0[0][0] = servo_data_arm.data0[0][0] + 20;
				servo_data_arm.data0[0][1] = servo_data_arm.data0[0][1] - 20;
			}
			else
			{
				servo_data_arm.data0[0][0] = servo_data_arm.data0[0][0] - 20;
				servo_data_arm.data0[0][1] = servo_data_arm.data0[0][1] + 20;
			}
			switches.live_play_arm_v--;
		}

		/*z[hig`f[^gȂj*/
		if(switches.live_play_arm_h > 1)
		{
			if(switches.live_dir_arm > 0)
			{
				servo_data_arm.data0[1][0] = servo_data_arm.data0[1][0] + 20;
				servo_data_arm.data0[1][1] = servo_data_arm.data0[1][1] - 20;
				/*^b`ZT`FbNA瓮Iiŉ׏d͒j*/
				i = P4DR.BYTE & 11;
				if(i < 11) switches.live_play_arm_h = 1;
			}
			else
			{
				servo_data_arm.data0[1][0] = servo_data_arm.data0[1][0] - 20;
				servo_data_arm.data0[1][1] = servo_data_arm.data0[1][1] + 20;
			}
			switches.live_play_arm_h--;
		}

		/*********************************************************************/
		/*`cwkQOQ̓ǂݎ*/
		if(switches.adxl_on == 1)
		{
			read_adxl(&sio);
		}

		/*20m sec `FbN*/
		while(ITU0.TCNT < 50000);
	}
}

/********************************************************************/
/********************************************************************/
void servo_update(struct SERVO_DATA *servo_data)
{
unsigned char		i, j;
float				diff_f;

	if(servo_data->data_num == 0) return;

	for(j = 0; j < 2; j++)
	{
		for(i = 0; i < 4; i++)
		{
			servo_data->v0[i][j] = servo_data->v0[i][j] + servo_data->a0[i][j]
				* servo_data->brake_flg[i][j];/*ɐ*/

			/**/
			diff_f = servo_data->v0[i][j] * servo_data->direction[i][j];

			servo_data->data0_f[i][j] = servo_data->data0_f[i][j] + diff_f;
			servo_data->data0[i][j] = (int)servo_data->data0_f[i][j];

			/*s[N߂H*/
			if(servo_data->data_num == servo_data->brake_point + 1)
			{
				servo_data->brake_flg[i][j] = -1.0;
			}

			if(servo_data->data_num == 0)
			{
				/*o̓f[^ڕWlɍ킹āA[^[~߂*/
				servo_data->data0[i][j] = servo_data->data1[i][j];
				servo_data->a0[i][j] = 0.0;
				servo_data->brake_flg[i][j] = 0.0;
				servo_data->direction[i][j] = 0.0;
				servo_data->v0[i][j] = 0.0;
				servo_data->v_max[i][j] = 0.0;
			}
		}
	}
	/*IH*/
	if(servo_data->data_num > 0) servo_data->data_num--;

	return;
}